//
//  Task.h
//  Tasks
//
//  Copyright (c) 2013 Cultured Code. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface TSTask : NSObject {
    NSDate *modified;
    BOOL *done;
}
- (TSTask*)init;
- (TSTask*)initWithTitle:(NSString*)name;

- (void)setModified: (NSDate *)date;

@property(nonatomic,strong) NSString* title;

-(void) setTitle:(NSString *)title;

-(NSDate *)modifiedDate;
-(NSString *)modifiedString;

// Children
@property (strong) NSMutableArray* childrenTasks;
@property (strong) id parentTask;
- (void)addChild:(TSTask*)child;
- (void)removeChild:(TSTask*)child;

// Completed
-(BOOL)completed;
- (BOOL)notCompleted;
- (void)switchDone;

- (void)makeAllChildrenComplete;
- (void)deleteChildren;


@end




