//
//  Task.m
//  Tasks
//
//  Copyright (c) 2013 Cultured Code. All rights reserved.
//

#import "TSTask.h"

#define NOW [NSDate date]

@implementation TSTask
@synthesize title;
@synthesize childrenTasks;


- (TSTask*)init; {
    if (!(self = [super init])) return nil;

    title = @"<no title>";
    modified = 0;
    return self;
}
- (TSTask *)initWithTitle:(NSString*)name;
{
    if (!(self = [super init])) return nil;
    title = name;
    
    return self;
}

-(void)dealloc
{
    title = nil;
    [childrenTasks removeAllObjects];
}
- (void)setTitle: (NSString *) t; {
    modified = NOW;
    self.title = t;
}


- (void)setModified: (NSDate *)date;
{
    modified = date;
}


-(NSDate*)modifiedDate; {
    return modified;
}
-(NSString *)modifiedString;
{
    NSCalendar* cal = [[NSCalendar alloc] initWithCalendarIdentifier:NSCalendarIdentifierISO8601];
    NSString* ret;
    if(modified)
    {
        NSDateFormatter *f = [[NSDateFormatter alloc] init];
        [f setCalendar:cal];
        ret = [f stringFromDate:modified];
    }else
        return @"not yet modified";

    return ret;
}


- (void)addChild:(TSTask*)child;
{
    modified = NOW;
    [childrenTasks addObject:child];
    [child setParentTask:self];
}

- (void)removeChild:(TSTask*)child { [childrenTasks removeObject:child]; }


- (void)switchDone;
{
    BOOL newDone = NO;
    if (done)
        done = newDone;
    else
        newDone = YES;

    done = newDone;
}

-(BOOL)completed; {
    if (done) return YES;
    else return NO;
}
- (BOOL)notCompleted;
{
    if (!done)
        return NO;
    else return YES;

}



- (void) makeAllChildrenComplete;
{
    for(int l=0;l!=childrenTasks.count;l=l++)
        if ([[childrenTasks objectAtIndex:l] notCompleted])
            [[childrenTasks objectAtIndex:l] switchDone];
}
- (void)deleteChildren;
{
    for(int l=0;l<=childrenTasks.count;l=l++) {
        [childrenTasks removeObjectAtIndex:l];
    }
}


@end







